Created: 2014-03-17 Assigned To: Alexander Opitz
Updated: 2014-03-17 Due date:
TYPO3 Version: 6.2
PHP Version: 5.4
Complexity:
Is Regression: No
Sprint Focus:
Subject: Cannot update extension in EM
Description

I usually cannot update an extension with the built-in method in the list. Most of the time, first try does not show the dialog showing the
update comments in newer versions and if it shows up (just tried a few minutes ago on master on production), it fataled with
"extension XY is not loaded" in the middle of the upgrade process (extension was marked as inactive in PackageStates.php but I had
to manually removed typo3temp/Cache).

Tested with:

- image_autoresize 1.4.0
- was active before update
- wanting to update it to 1.5.0
- falaled as described
- was inactive in PackageStates.php
- was still at 1.4.0 on disk

Related issues:
related to Core - Bug # 54906: Fatal error: Interface 'Psr\Log\LoggerInterfac... Resolved 2014-03-12 2014-03-12
related to Core - Bug # 56652: Unable to upgrade extensions with extension ma... Closed 2014-03-07

Associated revisions
Revision ae444d93 - 2014-03-17 12:37 - Alexander Opitz

[BUGFIX] Update $GLOBALS['TYPO3_LOADED_EXT'] on package change

If a package is (un)installed we need to update
$GLOBALS['TYPO3_LOADED_EXT']. ExtensionManagementUtility depends on
the actuality of this array.

Resolves: #56978
Releases: 6.2
Change-Id: I969b84a624a6a9f74b87fdd85b9c4c3a7b49750a
Reviewed-on: https://review.typo3.org/28459
Reviewed-by: Thomas Maroschik
Tested-by: Thomas Maroschik
Reviewed-by: Jigal van Hemert
Tested-by: Jigal van Hemert
Reviewed-by: Xavier Perseguers
Tested-by: Xavier Perseguers
History
#1 - 2014-03-17 10:37 - Xavier Perseguers

Tried again on another website, with dd_googlesitemap, 1.3.0 to 1.3.1:

[17-Mar-2014 09:34:43 UTC] PHP Warning:  file_put_contents(/path/to/typo3temp/Cache/Data/cache_classes/5326c1b3a7ff4.temp): failed to
open stream: No such file or directory in /mnt/ebs/data1/typo3share/master/typo3/sysext/core/Classes/Cache/Backend/SimpleFileBackend.php
on line 238
[17-Mar-2014 09:34:43 UTC] PHP Warning:  file_put_contents(/path/to/typo3temp/Cache/Data/cache_classes/5326c1b3a8fd8.temp): failed to
open stream: No such file or directory in /mnt/ebs/data1/typo3share/master/typo3/sysext/core/Classes/Cache/Backend/SimpleFileBackend.php
on line 238
[17-Mar-2014 09:34:43 UTC] PHP Fatal error:  Class 'TYPO3\CMS\Core\Cache\Exception' not found in
/mnt/ebs/data1/typo3share/master/typo3/sysext/core/Classes/Cache/Backend/SimpleFileBackend.php on line 241
[17-Mar-2014 09:35:11 UTC] PHP Warning:  Invalid argument supplied for foreach() in
/mnt/ebs/data1/typo3share/master/typo3/sysext/core/Classes/Package/PackageManager.php on line 228
[17-Mar-2014 09:35:18 UTC] PHP Fatal error:  Uncaught exception
'TYPO3\CMS\Extbase\Object\Container\Exception\UnknownObjectException' with message 'Could not analyse
class:TYPO3\CMS\Fluid\Core\Parser\Configuration maybe not loaded or no autoloader?' in
/mnt/ebs/data1/typo3share/master/typo3/sysext/extbase/Classes/Object/Container/ClassInfoFactory.php:51
Stack trace:
#0 /mnt/ebs/data1/typo3share/master/typo3/sysext/extbase/Classes/Object/Container/Container.php(325):
TYPO3\CMS\Extbase\Object\Container\ClassInfoFactory->buildClassInfoFromClassName('TYPO3\CMS\Fluid...')
#1 /mnt/ebs/data1/typo3share/master/typo3/sysext/extbase/Classes/Object/Container/Container.php(167):
TYPO3\CMS\Extbase\Object\Container\Container->getClassInfo('TYPO3\CMS\Fluid...')
#2 /mnt/ebs/data1/typo3share/master/typo3/sysext/extbase/Classes/Object/Container/Container.php(122):
TYPO3\CMS\Extbase\Object\Container\Container->getInstanceInternal('TYPO3\CMS\Fluid...', Array)
#3 /mnt/ebs/data1/typo3share/master/typo3/sysext/extbase/Classes/Object/ObjectManager.php(108): TYPO3\CMS\Extbase\O in
/mnt/ebs/data1/typo3share/master/typo3/sysext/extbase/Classes/Object/Container/ClassInfoFactory.php on line 51
[17-Mar-2014 09:35:41 UTC] PHP Fatal error:  Uncaught exception 'RuntimeException' with message 'Could not acquire lock for ClassLoader
cache creation.' in /mnt/ebs/data1/typo3share/master/typo3/sysext/core/Classes/Core/ClassLoader.php:702
Stack trace:
#0 /mnt/ebs/data1/typo3share/master/typo3/sysext/core/Classes/Core/ClassLoader.php(229):
TYPO3\CMS\Core\Core\ClassLoader->acquireLock()
#1 /mnt/ebs/data1/typo3share/master/typo3/sysext/core/Classes/Core/ClassLoader.php(170):
TYPO3\CMS\Core\Core\ClassLoader->buildCachedClassLoadingInformation('bitmotion_nawse...', 'Bitmotion\NawSe...')
#2 [internal function]: TYPO3\CMS\Core\Core\ClassLoader->loadClass('Bitmotion\NawSe...')
#3 [internal function]: spl_autoload_call('Bitmotion\NawSe...')
#4 /path/to/typo3conf/ext/naw_securedl/Classes/Core/ObjectManager.php(26): interface_exists('Bitmotion\NawSe...')
#5 /path/to/typo3temp/Cache/Code/cache_core/ext_localconf_eb87ec4b43513e65a53e4cda0a83fd592921586d.php(1643):
Bitmotion\NawSecuredl\Core\O in /mnt/ebs/data1/typo3share/master/typo3/sysext/core/Classes/Core/ClassLoader.php on line 702

#2 - 2014-03-17 10:42 - Alexander Opitz
- Status changed from New to Accepted

#3 - 2014-03-17 10:55 - Alexander Opitz

The correct stacktrace is following:

#16 TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath("image_autoresize")
#15 require("[...]/typo3conf/ext/image_autoresize/ext_tables.php")
#14 TYPO3\CMS\Core\Utility\ExtensionManagementUtility::loadSingleExtTablesFiles()

2015-08-04 2/3



#13 TYPO3\CMS\Core\Utility\ExtensionManagementUtility::loadExtTables(boolean)
#12 TYPO3\CMS\Core\Core\Bootstrap::loadExtensionTables(boolean)
#11 TYPO3\CMS\Extensionmanager\Utility\InstallUtility::reloadCaches()
#10
TYPO3\CMS\Extensionmanager\Controller\DownloadController::prepareExtensionForImport(TYPO3\CMS\Extensionmanager\Domain\Model\Extension)
#9 TYPO3\CMS\Extensionmanager\Controller\DownloadController::updateExtensionAction()
#8 call_user_func_array(array, array)
#7 TYPO3\CMS\Extbase\Mvc\Controller\ActionController::callActionMethod()
#6 TYPO3\CMS\Extbase\Mvc\Controller\ActionController::processRequest(TYPO3\CMS\Extbase\Mvc\Web\Request, TYPO3\CMS\Extbase\Mvc\Web\Response)
#5 TYPO3\CMS\Extbase\Mvc\Dispatcher::dispatch(TYPO3\CMS\Extbase\Mvc\Web\Request, TYPO3\CMS\Extbase\Mvc
xtension)
#9 TYPO3\CMS\Extensionmanager\Controller\DownloadController::updateExtensionAction()
#8 call_user_func_array(array, array)
#7 TYPO3\CMS\Extbase\Mvc\Controller\ActionController::callActionMethod()
#6 TYPO3\CMS\Extbase\Mvc\Controller\ActionController::processRequest(TYPO3\CMS\Extbase\Mvc\Web\Request,
TYPO3\CMS\Extbase\Mvc\Web\Response)
#5 TYPO3\CMS\Extbase\Mvc\Dispatcher::dispatch(TYPO3\CMS\Extbase\Mvc\Web\Request, TYPO3\CMS\Extbase\Mvc\Web\Response)
#4 TYPO3\CMS\Extbase\Mvc\Web\BackendRequestHandler::handleRequest()
#3 TYPO3\CMS\Extbase\Core\Bootstrap::handleRequest()
#2 TYPO3\CMS\Extbase\Core\Bootstrap::run("", array)
#1 TYPO3\CMS\Extbase\Core\ModuleRunner::callModule("tools_ExtensionmanagerExtensionmanager")

#4 - 2014-03-17 11:02 - Alexander Opitz

After fixing #54906 this seams the next pitfall while update.

#5 - 2014-03-17 11:42 - Alexander Opitz
- Assigned To set to Alexander Opitz

#6 - 2014-03-17 11:49 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28459

#7 - 2014-03-17 12:02 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28459

#8 - 2014-03-17 13:30 - Alexander Opitz
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:ae444d93be18b367d0dcf605ecbb2d10506c9034.
